Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_QtReactor Class Reference

An object-oriented event demultiplexor and event handler dispatcher that uses the Qt Library. This class declaration also uses the extension facilities provided by the Qt. So, readers of the class declaration should not be upset with the appearence of the Keywords like Q_OBJECT, private slots etc. They are specific to Qt which uses these as a call back methods implementation mechanism. More...

`#include <QtReactor.h>`

Inheritance diagram for ACE_QtReactor:

[legend]
Collaboration diagram for ACE_QtReactor:

[legend]
List of all members.

## Public Methods
| ACE_QtReactor (QApplication *qapp=NULL, size_t size=DEFAULT_SIZE, int restart=0, ACE_Sig_Handler *handler=0)
virtual | ~ACE_QtReactor (void)
void | qapplication (QApplication *qapp)
virtual long | schedule_timer (ACE_Event_Handler *handler, const void *arg, const ACE_Time_Value &delay_time, const ACE_Time_Value &interval)
| Schedule an ACE_Event_Handler that will expire after an amount of time. More...
virtual int | cancel_timer (ACE_Event_Handler *handler, int dont_call_handle_close=1)
| Cancel all Event_Handlers that match the address of <event_handler>. Returns number of handlers cancelled. More...
virtual int | cancel_timer (long timer_id, const void **arg=0, int dont_call_handle_close=1)
| Cancel the single Event_Handler that matches the <timer_id> value (which was returned from the schedule method). More...
## Protected Types
typedef ACE_Map_Manager< ACE_HANDLE, QSocketNotifier *, ACE_Null_Mutex > | MAP
| Typedef of a map. More...
## Protected Methods
virtual int | register_handler_i (ACE_HANDLE handle, ACE_Event_Handler *handler, ACE_Reactor_Mask mask)
| Register a single <handler>. More...
virtual int | register_handler_i (const ACE_Handle_Set &handles, ACE_Event_Handler *handler, ACE_Reactor_Mask mask)
| Register a set of <handlers> with Qt. More...
virtual int | remove_handler_i (ACE_HANDLE handle, ACE_Reactor_Mask mask)
| Remove the <handler> associated with this <handle>. More...
virtual int | remove_handler_i (const ACE_Handle_Set &handles, ACE_Reactor_Mask mask)
| Remove a set of <handles>. More...
virtual int | wait_for_multiple_events (ACE_Select_Reactor_Handle_Set &handle_set, ACE_Time_Value *max_wait_time)
| Wait for events to occur. More...
virtual int | QtWaitForMultipleEvents (int width, ACE_Select_Reactor_Handle_Set &wait_set, ACE_Time_Value *max_wait_time)
## Protected Attributes
QApplication * | qapp_
| Some Qt stuff that we need to have. More...
MAP | read_notifier_
| A notifier for a read. More...
MAP | write_notifier_
| A write notifier. More...
MAP | exception_notifier_
| An exception notifier. More...
QTimer * | qtime_
| The timer class that would provide timer-sgnals & single-shot timers. More...
## Private Slots
void | read_event (int FD)
| Dispatch a Read Event. More...
void | write_event (int FD)
| Dispatch a Write Event. More...
void | exception_event (int FD)
| Dispatch an exception event. More...
void | timeout_event (void)
| Dispach a timeout event. More...
## Private Methods
void | reset_timeout (void)
| This method ensures there's an Qt timeout for the first timeout in the Reactor's Timer_Queue. More...
| ACE_QtReactor (const ACE_QtReactor &)
| Deny access since member-wise won't work... More...
ACE_QtReactor & | operator= (const ACE_QtReactor &)

## Detailed Description

An object-oriented event demultiplexor and event handler dispatcher that uses the Qt Library. This class declaration also uses the extension facilities provided by the Qt. So, readers of the class declaration should not be upset with the appearence of the Keywords like Q_OBJECT, private slots etc. They are specific to Qt which uses these as a call back methods implementation mechanism.

## Member Typedef Documentation

typedef ACE_Map_Manager<ACE_HANDLE, QSocketNotifier *, ACE_Null_Mutex> ACE_QtReactor::MAP`[protected]`

| Typedef of a map.

## Constructor & Destructor Documentation

ACE_QtReactor::ACE_QtReactor | ( | QApplication * | qapp = NULL,
|  | size_t | size = DEFAULT_SIZE,
|  | int | restart = 0,
|  | ACE_Sig_Handler * | handler = 0
| ) |

ACE_QtReactor::~ACE_QtReactor | ( | void |  | ) | `[virtual]`

ACE_QtReactor::ACE_QtReactor | ( | const ACE_QtReactor & |  | ) | `[private]`

| Deny access since member-wise won't work...

## Member Function Documentation

int ACE_QtReactor::cancel_timer | ( | long | timer_id,
|  | const void ** | arg = 0,
|  | int | dont_call_handle_close = 1
| ) | `[virtual]`

| Cancel the single Event_Handler that matches the <timer_id> value (which was returned from the schedule method). If arg is non-NULL then it will be set to point to the ``magic cookie'' argument passed in when the Event_Handler was registered. This makes it possible to free up the memory and avoid memory leaks. Returns 1 if cancellation succeeded and 0 if the <timer_id> wasn't found. Reimplemented from ACE_Reactor_Impl.

int ACE_QtReactor::cancel_timer | ( | ACE_Event_Handler * | handler,
|  | int | dont_call_handle_close = 1
| ) | `[virtual]`

| Cancel all Event_Handlers that match the address of <event_handler>. Returns number of handlers cancelled. Reimplemented from ACE_Reactor_Impl.

void ACE_QtReactor::exception_event | ( | int | handle | ) | `[private, slot]`

| Dispatch an exception event.

ACE_QtReactor& ACE_QtReactor::operator= | ( | const ACE_QtReactor & |  | ) | `[private]`

void ACE_QtReactor::qapplication | ( | QApplication * | qapp | ) |

int ACE_QtReactor::QtWaitForMultipleEvents | ( | int | width,
|  | ACE_Select_Reactor_Handle_Set & | wait_set,
|  | ACE_Time_Value * | max_wait_time
| ) | `[protected, virtual]`

void ACE_QtReactor::read_event | ( | int | handle | ) | `[private, slot]`

| Dispatch a Read Event.

int ACE_QtReactor::register_handler_i | ( | const ACE_Handle_Set & | handles,
|  | ACE_Event_Handler * | handler,
|  | ACE_Reactor_Mask | mask
| ) | `[protected, virtual]`

| Register a set of <handlers> with Qt. Reimplemented from ACE_Select_Reactor_T.

int ACE_QtReactor::register_handler_i | ( | ACE_HANDLE | handle,
|  | ACE_Event_Handler * | handler,
|  | ACE_Reactor_Mask | mask
| ) | `[protected, virtual]`

| Register a single <handler>. Reimplemented from ACE_Select_Reactor_T.

int ACE_QtReactor::remove_handler_i | ( | const ACE_Handle_Set & | handles,
|  | ACE_Reactor_Mask | mask
| ) | `[protected, virtual]`

| Remove a set of <handles>. Reimplemented from ACE_Select_Reactor_T.

int ACE_QtReactor::remove_handler_i | ( | ACE_HANDLE | handle,
|  | ACE_Reactor_Mask | mask
| ) | `[protected, virtual]`

| Remove the <handler> associated with this <handle>. Reimplemented from ACE_Select_Reactor_T.

void ACE_QtReactor::reset_timeout | ( | void |  | ) | `[private]`

| This method ensures there's an Qt timeout for the first timeout in the Reactor's Timer_Queue.

long ACE_QtReactor::schedule_timer | ( | ACE_Event_Handler * | handler,
|  | const void * | arg,
|  | const ACE_Time_Value & | delay_time,
|  | const ACE_Time_Value & | interval
| ) | `[virtual]`

  | Schedule an ACE_Event_Handler that will expire after an amount of time. The return value of this method, a timer_id value, uniquely identifies the event_handler in the ACE_Reactor's internal list of timers. This timer_id value can be used to cancel the timer with the cancel_timer() call. See also: cancel_timer() , reset_timer_interval() Parameters:
  event_handler | event handler to schedule on reactor
  arg | argument passed to the handle_timeout() method of event_handler
  delta | time interval after which the timer will expire
  interval | time interval after which the timer will be automatically rescheduled
Returns: -1 on failure, a timer_id value on success Reimplemented from ACE_Reactor_Impl.

void ACE_QtReactor::timeout_event | ( | void |  | ) | `[private, slot]`

| Dispach a timeout event.

int ACE_QtReactor::wait_for_multiple_events | ( | ACE_Select_Reactor_Handle_Set & | handle_set,
|  | ACE_Time_Value * | max_wait_time
| ) | `[protected, virtual]`

| Wait for events to occur. Reimplemented from ACE_Select_Reactor_T.

void ACE_QtReactor::write_event | ( | int | handle | ) | `[private, slot]`

| Dispatch a Write Event.

## Member Data Documentation

MAP ACE_QtReactor::exception_notifier_`[protected]`

| An exception notifier.

QApplication* ACE_QtReactor::qapp_`[protected]`

| Some Qt stuff that we need to have.

QTimer* ACE_QtReactor::qtime_`[protected]`

| The timer class that would provide timer-sgnals & single-shot timers.

MAP ACE_QtReactor::read_notifier_`[protected]`

| A notifier for a read.

MAP ACE_QtReactor::write_notifier_`[protected]`

| A write notifier.

The documentation for this class was generated from the following files:

- QtReactor.h
- QtReactor.cpp